/*
this file is part of Silenda v0.1 
- Copyright © Alexander Weinhold, 2010

Silenda is a simple command line tool for hiding ASCII-Strings in
(uncompressed) Bitmaps and retrieving them again.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef SILENDA_H
#define SILENDA_H

#include <stdlib.h>

void end(char* errorString) 
{
	fprintf(stderr,"%s \n", errorString);
	exit(-1);
}

/* get the offset of the actual picture data
	(where it does not hurt to flip the LSB of a byte) */
int getPictureOffset(FILE *ifp) 
{
	unsigned char tempchar;
	long byteCounter=0;
	int pictureOffset;
	
	/* Offset in a correct Bitmap encoding is coded into Bytes 10-13 */
	while (!feof(ifp)&&byteCounter<=13) {		
			tempchar= fgetc(ifp);
			char pictureOffsetArray[4];
			
			/* The first two bytes of a Bitmap file have to be ASCII B and M */
			if ((byteCounter == 0 && tempchar != 'B')|| (byteCounter == 1 && tempchar != 'M'))
				end("File does not seem to be a Bitmap");

			if (byteCounter >= 10 && byteCounter <= 13) 
				pictureOffsetArray[byteCounter-10] = tempchar;

			if (byteCounter == 13)
				pictureOffset = *((int *) pictureOffsetArray);
			

			byteCounter++;
		}

	rewind(ifp);
	return pictureOffset;
}

#endif
